/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production Expr : {@link ASTNode};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:103
 */
public abstract class Expr extends ASTNode<ASTNode> implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public Expr clone() throws CloneNotSupportedException {
    Expr node = (Expr) super.clone();
    return node;
  }
  /**
   * 
   * @ast method
   * @aspect TypeScopePropagation
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:461
   */

  public SimpleSet keepAccessibleTypes(SimpleSet oldSet) {
    SimpleSet newSet = SimpleSet.emptySet;
    TypeDecl hostType = hostType();
    for(Iterator iter = oldSet.iterator(); iter.hasNext(); ) {
      TypeDecl t = (TypeDecl)iter.next();
      if((hostType != null && t.accessibleFrom(hostType)) || (hostType == null && t.accessibleFromPackage(hostPackage())))
        newSet = newSet.add(t);
    }
    return newSet;
  }
  /**
   * 
     * Remove fields that are not accessible when using this Expr as qualifier
     * @return a set containing the accessible fields
     
   * @ast method
   * @aspect VariableScope
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:169
   */

  public SimpleSet keepAccessibleFields(SimpleSet oldSet) {
    SimpleSet newSet = SimpleSet.emptySet;
    for(Iterator iter = oldSet.iterator(); iter.hasNext(); ) {
      Variable v = (Variable)iter.next();
      if(v instanceof FieldDeclaration) {
        FieldDeclaration f = (FieldDeclaration)v;
        if(mayAccess(f))
          newSet = newSet.add(f);
      }
    }
    return newSet;
  }
  /**
   * 
     * @see "JLS $6.6.2.1"
     * @return true if the expression may access the given field
     
   * @ast method
   * @aspect VariableScope
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:196
   */

  public boolean mayAccess(FieldDeclaration f) {
    if(f.isPublic()) {
      return true;
    } else if(f.isProtected()) {
      if(f.hostPackage().equals(hostPackage()))
        return true;
      return hostType().mayAccess(this, f);
    } else if(f.isPrivate()) {
      return f.hostType().topLevelType() == hostType().topLevelType();
    } else {
      return f.hostPackage().equals(hostType().hostPackage());
    }
  }
  /**
   * 
   * @ast method
   * @aspect QualifiedNames
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:106
   */

  public Dot qualifiesAccess(Access access) {
    Dot dot = new Dot(this, access);
    dot.setStart(this.getStart());
    dot.setEnd(access.getEnd());
    return dot;
  }
  /**
   * 
   * @ast method
   * @aspect CodeGeneration
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:297
   */

  public void emitStore(CodeGeneration gen) { error("emitStore called with " + getClass().getName()); }
  /**
   * 
   * @ast method
   * @aspect CodeGenerationBinaryOperations
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:568
   */

  void emitOperation(CodeGeneration gen) {error();}
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:233
   */

  protected boolean needsPush() {
    ASTNode n = getParent();
    while(n instanceof ParExpr)
      n = n.getParent();
    return !(n instanceof ExprStmt);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:372
   */

  public void createAssignSimpleLoadDest(CodeGeneration gen) {
  }
  /**
   * 
     * duplicate top value on stack and store below destination element
     
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:388
   */

  public void createPushAssignmentResult(CodeGeneration gen) {
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:406
   */

  public void createAssignLoadDest(CodeGeneration gen) {
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1052
   */

  protected void emitBooleanCondition(CodeGeneration gen) {
    emitEvalBranch(gen);
    int end_label = hostType().constantPool().newLabel();
    gen.addLabel(false_label());
    BooleanLiteral.push(gen, false);
    gen.emitGoto(end_label);
    gen.changeStackDepth(-1); // discard false from stack depth computation
    gen.addLabel(true_label());
    BooleanLiteral.push(gen, true);
    gen.addLabel(end_label);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1090
   */

  public void refined_CreateBCode_Expr_emitEvalBranch(CodeGeneration gen) {
    if(isTrue())
      gen.emitGoto(true_label());
    else if(isFalse())
      gen.emitGoto(false_label());
    else {
      createBCode(gen);
      gen.emitCompare(Bytecode.IFNE, true_label());
      gen.emitGoto(false_label());
      //gen.emitCompare(Bytecode.IFEQ, false_label());
      //gen.emitGoto(true_label());
    }
  }
  /**
   * 
   * @ast method
   * @aspect MethodSignature15
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:91
   */

  protected SimpleSet chooseConstructor(Collection constructors, List argList) {
    SimpleSet potentiallyApplicable = SimpleSet.emptySet;
    // select potentially applicable constructors
    for(Iterator iter = constructors.iterator(); iter.hasNext(); ) {
      ConstructorDecl decl = (ConstructorDecl)iter.next();
      if(decl.potentiallyApplicable(argList) && decl.accessibleFrom(hostType()))
        potentiallyApplicable = potentiallyApplicable.add(decl);
    }
    // first phase
    SimpleSet maxSpecific = SimpleSet.emptySet;
    for(Iterator iter = potentiallyApplicable.iterator(); iter.hasNext(); ) {
      ConstructorDecl decl = (ConstructorDecl)iter.next();
      if(decl.applicableBySubtyping(argList))
        maxSpecific = mostSpecific(maxSpecific, decl);
    }

    // second phase
    if(maxSpecific.isEmpty()) {
      for(Iterator iter = potentiallyApplicable.iterator(); iter.hasNext(); ) {
        ConstructorDecl decl = (ConstructorDecl)iter.next();
        if(decl.applicableByMethodInvocationConversion(argList))
          maxSpecific = mostSpecific(maxSpecific, decl);
      }
    }

    // third phase
    if(maxSpecific.isEmpty()) {
      for(Iterator iter = potentiallyApplicable.iterator(); iter.hasNext(); ) {
        ConstructorDecl decl = (ConstructorDecl)iter.next();
        if(decl.isVariableArity() && decl.applicableVariableArity(argList))
          maxSpecific = mostSpecific(maxSpecific, decl);
      }
    }
    return maxSpecific;
  }
  /**
   * 
   * @ast method
   * @aspect MethodSignature15
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:128
   */

  protected static SimpleSet mostSpecific(SimpleSet maxSpecific, ConstructorDecl decl) {
    if(maxSpecific.isEmpty())
      maxSpecific = maxSpecific.add(decl);
    else {
      if(decl.moreSpecificThan((ConstructorDecl)maxSpecific.iterator().next()))
        maxSpecific = SimpleSet.emptySet.add(decl);
      else if(!((ConstructorDecl)maxSpecific.iterator().next()).moreSpecificThan(decl))
        maxSpecific = maxSpecific.add(decl);
    }
    return maxSpecific;
  }
  /**
   * 
   * @ast method
   * 
   */

  public Expr() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 0;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        false_label_computed = false;
    true_label_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
   * @ast method
   * @aspect AutoBoxingCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/AutoBoxingCodegen.jrag:111
   */

    public void emitEvalBranch(CodeGeneration gen) {
    if(type().isReferenceType()) {
      createBCode(gen);
      type().emitUnboxingOperation(gen);
      gen.emitCompare(Bytecode.IFEQ, false_label());
      gen.emitGoto(true_label());
    }
    else {
      refined_CreateBCode_Expr_emitEvalBranch(gen);
    }
  }
  /**
   * @attribute syn
   * @aspect TypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:276
   */

@SuppressWarnings({"unchecked", "cast"})
  public abstract TypeDecl type();
    /**
     * @attribute syn
     * @aspect ConstantExpression
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ConstantExpression.jrag:11
     */
  public Constant constant() {
    ASTNode$State state = state();
    try {
        throw new UnsupportedOperationException("ConstantExpression operation constant" +
          " not supported for type " + getClass().getName());
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect ConstantExpression
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ConstantExpression.jrag:199
     */
  public boolean representableIn(TypeDecl t) {
    ASTNode$State state = state();
    try {
        if (!type().isByte() && !type().isChar() && !type().isShort() && !type().isInt()) {
          return false;
        }
        if (t.isByte())
          return constant().intValue() >= Byte.MIN_VALUE && constant().intValue() <= Byte.MAX_VALUE;
        if (t.isChar())
          return constant().intValue() >= Character.MIN_VALUE && constant().intValue() <= Character.MAX_VALUE;
        if (t.isShort())
          return constant().intValue() >= Short.MIN_VALUE && constant().intValue() <= Short.MAX_VALUE;
        if(t.isInt())
          return constant().intValue() >= Integer.MIN_VALUE && constant().intValue() <= Integer.MAX_VALUE;
        return false;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect ConstantExpression
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ConstantExpression.jrag:227
     */
  public boolean isConstant() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect ConstantExpression
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ConstantExpression.jrag:256
     */
  public boolean isTrue() {
    ASTNode$State state = state();
    try {  return isConstant() && type() instanceof BooleanType && constant().booleanValue();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect ConstantExpression
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ConstantExpression.jrag:257
     */
  public boolean isFalse() {
    ASTNode$State state = state();
    try {  return isConstant() && type() instanceof BooleanType && !constant().booleanValue();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DefiniteAssignment
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:58
     */
  public Variable varDecl() {
    ASTNode$State state = state();
    try {  return null;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:333
     */
  public boolean isDAafterFalse(Variable v) {
    ASTNode$State state = state();
    try {  return isTrue() || isDAbefore(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:332
     */
  public boolean isDAafterTrue(Variable v) {
    ASTNode$State state = state();
    try {  return isFalse() || isDAbefore(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:235
     */
  public boolean isDAafter(Variable v) {
    ASTNode$State state = state();
    try {  return (isDAafterFalse(v) && isDAafterTrue(v)) || isDAbefore(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:703
     */
  public boolean isDUafterFalse(Variable v) {
    ASTNode$State state = state();
    try {
        if(isTrue())
          return true;
        return isDUbefore(v);
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:702
     */
  public boolean isDUafterTrue(Variable v) {
    ASTNode$State state = state();
    try {
        if(isFalse())
          return true;
        return isDUbefore(v);
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:694
     */
  public boolean isDUafter(Variable v) {
    ASTNode$State state = state();
    try {  return (isDUafterFalse(v) && isDUafterTrue(v)) || isDUbefore(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect ConstructScope
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:32
     */
  public SimpleSet mostSpecificConstructor(Collection constructors) {
    ASTNode$State state = state();
    try {
        SimpleSet maxSpecific = SimpleSet.emptySet;
        for(Iterator iter = constructors.iterator(); iter.hasNext(); ) {
          ConstructorDecl decl = (ConstructorDecl)iter.next();
          if(applicableAndAccessible(decl)) {
            if(maxSpecific.isEmpty())
              maxSpecific = maxSpecific.add(decl);
            else {
              if(decl.moreSpecificThan((ConstructorDecl)maxSpecific.iterator().next()))
                maxSpecific = SimpleSet.emptySet.add(decl);
              else if(!((ConstructorDecl)maxSpecific.iterator().next()).moreSpecificThan(decl))
                maxSpecific = maxSpecific.add(decl);
            }
          }
        }
        return maxSpecific;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect ConstructScope
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:50
     */
  public boolean applicableAndAccessible(ConstructorDecl decl) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect LookupFullyQualifiedTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:83
     */
  public boolean hasQualifiedPackage(String packageName) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect TypeScopePropagation
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:430
     */
  public SimpleSet qualifiedLookupType(String name) {
    ASTNode$State state = state();
    try {  return keepAccessibleTypes(type().memberTypes(name));  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect VariableScope
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:148
     */
  public SimpleSet qualifiedLookupVariable(String name) {
    ASTNode$State state = state();
    try {
        if(type().accessibleFrom(hostType()))
          return keepAccessibleFields(type().memberFields(name));
        return SimpleSet.emptySet;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PositiveLiterals
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PositiveLiterals.jrag:15
     */
  public boolean isPositive() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Names
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/QualifiedNames.jrag:25
     */
  public String packageName() {
    ASTNode$State state = state();
    try {  return "";  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Names
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/QualifiedNames.jrag:62
     */
  public String typeName() {
    ASTNode$State state = state();
    try {  return "";  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:13
     */
  public boolean isTypeAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:17
     */
  public boolean isMethodAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:21
     */
  public boolean isFieldAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:25
     */
  public boolean isSuperAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:31
     */
  public boolean isThisAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:37
     */
  public boolean isPackageAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:41
     */
  public boolean isArrayAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:45
     */
  public boolean isClassAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:49
     */
  public boolean isSuperConstructorAccess() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect QualifiedNames
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:55
     */
  public boolean isLeftChildOfDot() {
    ASTNode$State state = state();
    try {  return hasParentDot() && parentDot().getLeft() == this;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect QualifiedNames
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:56
     */
  public boolean isRightChildOfDot() {
    ASTNode$State state = state();
    try {  return hasParentDot() && parentDot().getRight() == this;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect QualifiedNames
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:69
     */
  public AbstractDot parentDot() {
    ASTNode$State state = state();
    try {  return getParent() instanceof AbstractDot ? (AbstractDot)getParent() : null;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect QualifiedNames
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:70
     */
  public boolean hasParentDot() {
    ASTNode$State state = state();
    try {  return parentDot() != null;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect QualifiedNames
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:72
     */
  public Access nextAccess() {
    ASTNode$State state = state();
    try {  return parentDot().nextAccess();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect QualifiedNames
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:73
     */
  public boolean hasNextAccess() {
    ASTNode$State state = state();
    try {  return isLeftChildOfDot();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect NestedTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:503
     */
  public Stmt enclosingStmt() {
    ASTNode$State state = state();
    try {
        ASTNode node = this;
        while(node != null && !(node instanceof Stmt))
          node = node.getParent();
        return (Stmt)node;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect TypeCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:15
     */
  public boolean isVariable() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect TypeHierarchyCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeHierarchyCheck.jrag:20
     */
  public boolean isUnknown() {
    ASTNode$State state = state();
    try {  return type().isUnknown();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect TypeHierarchyCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeHierarchyCheck.jrag:150
     */
  public boolean staticContextQualifier() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:241
     */
  public boolean needsPop() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:253
     */
  public boolean isVarAccessWithAccessor() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean false_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int false_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:963
   */

  public int false_label() {
    

    
if(false_label_computed) {
  return false_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    false_label_value = false_label_compute();
      if(isFinal && num == state().boundariesCrossed){ false_label_computed = true; }
        return false_label_value;
  }
  /**
   * @apilevel internal
   */
  private int false_label_compute() {  return getParent().definesLabel() ? condition_false_label() : hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean true_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int true_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:965
   */

  public int true_label() {
    

    
if(true_label_computed) {
  return true_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    true_label_value = true_label_compute();
      if(isFinal && num == state().boundariesCrossed){ true_label_computed = true; }
        return true_label_value;
  }
  /**
   * @apilevel internal
   */
  private int true_label_compute() {  return getParent().definesLabel() ? condition_true_label() : hostType().constantPool().newLabel();  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1029
     */
  public boolean canBeTrue() {
    ASTNode$State state = state();
    try {  return !isFalse();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1039
     */
  public boolean canBeFalse() {
    ASTNode$State state = state();
    try {  return !isTrue();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Enums
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Enums.jrag:500
     */
  public boolean isEnumConstant() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
       * Finds the host type declaration of a class access.
       * Call this attribute only on expressions that return true for
       * isClassAccess or it may throw an error!
       * @return The TypeDecl corresponding to the accesssed class
       
     * @attribute syn
     * @aspect AnnotationsCodegen
     * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/AnnotationsCodegen.jrag:204
     */
  public TypeDecl classAccess() {
    ASTNode$State state = state();
    try {
        throw new Error(
            "Class access can only be computed for class access expressions");
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:11
     */
  public Collection<TypeDecl> throwTypes() {
    ASTNode$State state = state();
    try {
        Collection<TypeDecl> tts = new LinkedList<TypeDecl>();
        tts.add(type());
        return tts;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:111
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:115
     */
  public boolean isVariable(Variable var) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect DefiniteAssignment
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:15
   */

  public boolean isDest() {
    ASTNode$State state = state();
    boolean isDest_value = getParent().Define_boolean_isDest(this, null);
        return isDest_value;
  }
  /**
   * @attribute inh
   * @aspect DefiniteAssignment
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:25
   */

  public boolean isSource() {
    ASTNode$State state = state();
    boolean isSource_value = getParent().Define_boolean_isSource(this, null);
        return isSource_value;
  }
  /**
   * @attribute inh
   * @aspect DefiniteAssignment
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:49
   */

  public boolean isIncOrDec() {
    ASTNode$State state = state();
    boolean isIncOrDec_value = getParent().Define_boolean_isIncOrDec(this, null);
        return isIncOrDec_value;
  }
  /**
   * @attribute inh
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:234
   */

  public boolean isDAbefore(Variable v) {
    ASTNode$State state = state();
    boolean isDAbefore_Variable_value = getParent().Define_boolean_isDAbefore(this, null, v);
        return isDAbefore_Variable_value;
  }
  /**
   * @attribute inh
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:693
   */

  public boolean isDUbefore(Variable v) {
    ASTNode$State state = state();
    boolean isDUbefore_Variable_value = getParent().Define_boolean_isDUbefore(this, null, v);
        return isDUbefore_Variable_value;
  }
  /**
   * @attribute inh
   * @aspect LookupMethod
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupMethod.jrag:23
   */

  public Collection lookupMethod(String name) {
    ASTNode$State state = state();
    Collection lookupMethod_String_value = getParent().Define_Collection_lookupMethod(this, null, name);
        return lookupMethod_String_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:49
   */

  public TypeDecl typeBoolean() {
    ASTNode$State state = state();
    TypeDecl typeBoolean_value = getParent().Define_TypeDecl_typeBoolean(this, null);
        return typeBoolean_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:50
   */

  public TypeDecl typeByte() {
    ASTNode$State state = state();
    TypeDecl typeByte_value = getParent().Define_TypeDecl_typeByte(this, null);
        return typeByte_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:51
   */

  public TypeDecl typeShort() {
    ASTNode$State state = state();
    TypeDecl typeShort_value = getParent().Define_TypeDecl_typeShort(this, null);
        return typeShort_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:52
   */

  public TypeDecl typeChar() {
    ASTNode$State state = state();
    TypeDecl typeChar_value = getParent().Define_TypeDecl_typeChar(this, null);
        return typeChar_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:53
   */

  public TypeDecl typeInt() {
    ASTNode$State state = state();
    TypeDecl typeInt_value = getParent().Define_TypeDecl_typeInt(this, null);
        return typeInt_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:54
   */

  public TypeDecl typeLong() {
    ASTNode$State state = state();
    TypeDecl typeLong_value = getParent().Define_TypeDecl_typeLong(this, null);
        return typeLong_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:55
   */

  public TypeDecl typeFloat() {
    ASTNode$State state = state();
    TypeDecl typeFloat_value = getParent().Define_TypeDecl_typeFloat(this, null);
        return typeFloat_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:56
   */

  public TypeDecl typeDouble() {
    ASTNode$State state = state();
    TypeDecl typeDouble_value = getParent().Define_TypeDecl_typeDouble(this, null);
        return typeDouble_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:57
   */

  public TypeDecl typeString() {
    ASTNode$State state = state();
    TypeDecl typeString_value = getParent().Define_TypeDecl_typeString(this, null);
        return typeString_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:58
   */

  public TypeDecl typeVoid() {
    ASTNode$State state = state();
    TypeDecl typeVoid_value = getParent().Define_TypeDecl_typeVoid(this, null);
        return typeVoid_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:59
   */

  public TypeDecl typeNull() {
    ASTNode$State state = state();
    TypeDecl typeNull_value = getParent().Define_TypeDecl_typeNull(this, null);
        return typeNull_value;
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:72
   */

  public TypeDecl unknownType() {
    ASTNode$State state = state();
    TypeDecl unknownType_value = getParent().Define_TypeDecl_unknownType(this, null);
        return unknownType_value;
  }
  /**
   * @attribute inh
   * @aspect LookupFullyQualifiedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:86
   */

  public boolean hasPackage(String packageName) {
    ASTNode$State state = state();
    boolean hasPackage_String_value = getParent().Define_boolean_hasPackage(this, null, packageName);
        return hasPackage_String_value;
  }
  /**
   * @attribute inh
   * @aspect LookupFullyQualifiedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:95
   */

  public TypeDecl lookupType(String packageName, String typeName) {
    ASTNode$State state = state();
    TypeDecl lookupType_String_String_value = getParent().Define_TypeDecl_lookupType(this, null, packageName, typeName);
        return lookupType_String_String_value;
  }
  /**
   * @attribute inh
   * @aspect TypeScopePropagation
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:264
   */

  public SimpleSet lookupType(String name) {
    ASTNode$State state = state();
    SimpleSet lookupType_String_value = getParent().Define_SimpleSet_lookupType(this, null, name);
        return lookupType_String_value;
  }
  /**
   * @attribute inh
   * @aspect VariableScope
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:19
   */

  public SimpleSet lookupVariable(String name) {
    ASTNode$State state = state();
    SimpleSet lookupVariable_String_value = getParent().Define_SimpleSet_lookupVariable(this, null, name);
        return lookupVariable_String_value;
  }
  /**
   * @attribute inh
   * @aspect SyntacticClassification
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/SyntacticClassification.jrag:20
   */

  public NameType nameType() {
    ASTNode$State state = state();
    NameType nameType_value = getParent().Define_NameType_nameType(this, null);
        return nameType_value;
  }
  /**
   * @attribute inh
   * @aspect NestedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:510
   */

  public BodyDecl enclosingBodyDecl() {
    ASTNode$State state = state();
    BodyDecl enclosingBodyDecl_value = getParent().Define_BodyDecl_enclosingBodyDecl(this, null);
        return enclosingBodyDecl_value;
  }
  /**
   * @attribute inh
   * @aspect NestedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:567
   */

  public String hostPackage() {
    ASTNode$State state = state();
    String hostPackage_value = getParent().Define_String_hostPackage(this, null);
        return hostPackage_value;
  }
  /**
   * @attribute inh
   * @aspect NestedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:586
   */

  public TypeDecl hostType() {
    ASTNode$State state = state();
    TypeDecl hostType_value = getParent().Define_TypeDecl_hostType(this, null);
        return hostType_value;
  }
  /**
   * @attribute inh
   * @aspect TypeHierarchyCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeHierarchyCheck.jrag:11
   */

  public String methodHost() {
    ASTNode$State state = state();
    String methodHost_value = getParent().Define_String_methodHost(this, null);
        return methodHost_value;
  }
  /**
   * @attribute inh
   * @aspect TypeHierarchyCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeHierarchyCheck.jrag:134
   */

  public boolean inStaticContext() {
    ASTNode$State state = state();
    boolean inStaticContext_value = getParent().Define_boolean_inStaticContext(this, null);
        return inStaticContext_value;
  }
  /**
   * @attribute inh
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:995
   */

  public int condition_false_label() {
    ASTNode$State state = state();
    int condition_false_label_value = getParent().Define_int_condition_false_label(this, null);
        return condition_false_label_value;
  }
  /**
   * @attribute inh
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:999
   */

  public int condition_true_label() {
    ASTNode$State state = state();
    int condition_true_label_value = getParent().Define_int_condition_true_label(this, null);
        return condition_true_label_value;
  }
  /**
   * @attribute inh
   * @aspect GenericMethodsInference
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethodsInference.jrag:33
   */

  public TypeDecl assignConvertedType() {
    ASTNode$State state = state();
    TypeDecl assignConvertedType_value = getParent().Define_TypeDecl_assignConvertedType(this, null);
        return assignConvertedType_value;
  }
  /**
   * @attribute inh
   * @aspect GenericsTypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:271
   */

  public boolean inExtendsOrImplements() {
    ASTNode$State state = state();
    boolean inExtendsOrImplements_value = getParent().Define_boolean_inExtendsOrImplements(this, null);
        return inExtendsOrImplements_value;
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
