/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;

/**
 * @production GenericMethodDecl : {@link MethodDecl} ::= <span class="component">TypeParameter:{@link TypeVariable}*</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java5/grammar/GenericMethods.ast:2
 */
public class GenericMethodDecl extends MethodDecl implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public GenericMethodDecl clone() throws CloneNotSupportedException {
    GenericMethodDecl node = (GenericMethodDecl) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public GenericMethodDecl copy() {
    try {
      GenericMethodDecl node = (GenericMethodDecl) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public GenericMethodDecl fullCopy() {
    GenericMethodDecl tree = (GenericMethodDecl) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect GenericMethods
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:103
   */

  public ParMethodDecl newParMethodDecl(java.util.List typeArguments) {
    ParMethodDecl methodDecl = typeArguments.isEmpty() ? new RawMethodDecl() : new ParMethodDecl();
    // adding a link to GenericMethodDecl to be used during substitution
    // instead of the not yet existing parent link
    methodDecl.setGenericMethodDecl(this);
    List list = new List();
    if(typeArguments.isEmpty()) {
      GenericMethodDecl original = original();
      for(int i = 0; i < original.getNumTypeParameter(); i++)
        list.add(original.getTypeParameter(i).erasure().createBoundAccess());
    }
    else {
      for(Iterator iter = typeArguments.iterator(); iter.hasNext(); )
        list.add(((TypeDecl)iter.next()).createBoundAccess());
    }
    methodDecl.setTypeArgumentList(list);
    methodDecl.setModifiers((Modifiers)getModifiers().fullCopy());
    methodDecl.setTypeAccess(getTypeAccess().type().substituteReturnType(methodDecl));
    methodDecl.setID(getID());
    methodDecl.setParameterList(getParameterList().substitute(methodDecl));
    methodDecl.setExceptionList(getExceptionList().substitute(methodDecl));
    return methodDecl;
  }
  /**
   * 
   * @ast method
   * @aspect GenericMethodsPrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:216
   */

  private void ppTypeParameters(StringBuffer s) {
    s.append(" <");
    for(int i = 0; i < getNumTypeParameter(); i++) {
      if(i != 0) s.append(", ");
      original().getTypeParameter(i).toString(s);
    }
    s.append("> ");
  }
  /**
   * 
   * @ast method
   * @aspect GenericMethodsPrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:225
   */

  public void toString(StringBuffer s) {
    s.append(indent());
    getModifiers().toString(s);

    ppTypeParameters(s);

    getTypeAccess().toString(s);
    s.append(" " + getID());
    s.append("(");
    if(getNumParameter() > 0) {
      getParameter(0).toString(s);
      for(int i = 1; i < getNumParameter(); i++) {
        s.append(", ");
        getParameter(i).toString(s);
      }
    }
    s.append(")");
    if(getNumException() > 0) {
      s.append(" throws ");
      getException(0).toString(s);
      for(int i = 1; i < getNumException(); i++) {
        s.append(", ");
        getException(i).toString(s);
      }
    }
    if(hasBlock()) {
      s.append(" ");
      getBlock().toString(s);
    }
    else {
      s.append(";\n");
    }
  }
  /**
   * 
   * @ast method
   * @aspect LookupParTypeDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:1261
   */

  public BodyDecl substitutedBodyDecl(Parameterization parTypeDecl) {
    //System.out.println("Begin substituting generic " + signature() + " in " + hostType().typeName() + " with " + parTypeDecl.typeSignature());
    GenericMethodDecl m = new GenericMethodDecl(
      (Modifiers)getModifiers().fullCopy(),
      getTypeAccess().type().substituteReturnType(parTypeDecl),
      getID(),
      getParameterList().substitute(parTypeDecl),
      getExceptionList().substitute(parTypeDecl),
      new Opt(),
      (List)getTypeParameterList().fullCopy()
    );
    m.original = this;
    //System.out.println("End substituting generic " + signature());
    return m;
  }
  /**
   * 
   * @ast method
   * @aspect LookupParTypeDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:1277
   */

  
  public GenericMethodDecl original;
  /**
   * 
   * @ast method
   * @aspect JDimeGenericMethodsPrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/JDimeGenericMethods.jrag:62
   */

  private void ppJTypeParameters(StringBuffer s) {
    if (printConflict(s))
        return;

    s.append(" <");
    for(int i = 0; i < getNumTypeParameter(); i++) {
      if(i != 0) s.append(", ");
      original().getTypeParameter(i).prettyPrint(s);
    }
    s.append("> ");
  }
  /**
   * 
   * @ast method
   * @aspect JDimeGenericMethodsPrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/JDimeGenericMethods.jrag:74
   */

  public void prettyPrint(StringBuffer s) {
    if (printConflict(s))
        return;

    s.append(indent());
    getModifiers().prettyPrint(s);

    ppJTypeParameters(s);

    getTypeAccess().prettyPrint(s);
    s.append(" " + getID());
    s.append("(");
    if(getNumParameter() > 0) {
      getParameter(0).prettyPrint(s);
      for(int i = 1; i < getNumParameter(); i++) {
        s.append(", ");
        getParameter(i).prettyPrint(s);
      }
    }
    s.append(")");
    if(getNumException() > 0) {
      s.append(" throws ");
      getException(0).prettyPrint(s);
      for(int i = 1; i < getNumException(); i++) {
        s.append(", ");
        getException(i).prettyPrint(s);
      }
    }
    if(hasBlock()) {
      s.append(" ");
      getBlock().prettyPrint(s);
    }
    else {
      s.append(";\n");
    }
  }
  /**
   * 
   * @ast method
   * 
   */

  public GenericMethodDecl() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[6];
    setChild(new List(), 2);
    setChild(new List(), 3);
    setChild(new Opt(), 4);
    setChild(new List(), 5);
  }
  /**
   * 
   * @ast method
   * 
   */

  public GenericMethodDecl(Modifiers p0, Access p1, String p2, List<ParameterDeclaration> p3, List<Access> p4, Opt<Block> p5, List<TypeVariable> p6) {
    setChild(p0, 0);
    setChild(p1, 1);
    setID(p2);
    setChild(p3, 2);
    setChild(p4, 3);
    setChild(p5, 4);
    setChild(p6, 5);
  }
  /**
   * 
   * @ast method
   * 
   */

  public GenericMethodDecl(Modifiers p0, Access p1, beaver.Symbol p2, List<ParameterDeclaration> p3, List<Access> p4, Opt<Block> p5, List<TypeVariable> p6) {
    setChild(p0, 0);
    setChild(p1, 1);
    setID(p2);
    setChild(p3, 2);
    setChild(p4, 3);
    setChild(p5, 4);
    setChild(p6, 5);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 6;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        rawMethodDecl_computed = false;
    rawMethodDecl_value = null;
    lookupParMethodDecl_java_util_List_values = null;
    lookupParMethodDecl_java_util_List_list = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Modifiers child.
     * @param node The new node to replace the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setModifiers(Modifiers node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * @return The current node used as the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiers() {
    return (Modifiers) getChild(0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Modifiers child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiersNoTransform() {
    return (Modifiers) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the TypeAccess child.
     * @param node The new node to replace the TypeAccess child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeAccess(Access node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the TypeAccess child.
     * @return The current node used as the TypeAccess child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Access getTypeAccess() {
    return (Access) getChild(1);
  }
  /**
   * 
     * Retrieves the TypeAccess child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the TypeAccess child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Access getTypeAccessNoTransform() {
    return (Access) getChildNoTransform(1);
  }
  /**
   * 
     * Replaces the lexeme ID.
     * @param value The new value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setID(String value) {
    tokenString_ID = value;
  }
  /**
   * 
     * JastAdd-internal setter for lexeme ID using the Beaver parser.
     * @param symbol Symbol containing the new value for the lexeme ID
     * @apilevel internal
     
   * @ast method
   * 
   */

  public void setID(beaver.Symbol symbol) {
    if(symbol.value != null && !(symbol.value instanceof String))
    throw new UnsupportedOperationException("setID is only valid for String lexemes");
    tokenString_ID = (String)symbol.value;
    IDstart = symbol.getStart();
    IDend = symbol.getEnd();
  }
  /**
   * 
     * Retrieves the value for the lexeme ID.
     * @return The value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public String getID() {
    return tokenString_ID != null ? tokenString_ID : "";
  }
  /**
   * 
     * Replaces the Parameter list.
     * @param list The new list node to be used as the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setParameterList(List<ParameterDeclaration> list) {
    setChild(list, 2);
  }
  /**
   * 
     * Retrieves the number of children in the Parameter list.
     * @return Number of children in the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumParameter() {
    return getParameterList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the Parameter list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the Parameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumParameterNoTransform() {
    return getParameterListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the Parameter list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public ParameterDeclaration getParameter(int i) {
    return (ParameterDeclaration) getParameterList().getChild(i);
  }
  /**
   * 
     * Append an element to the Parameter list.
     * @param node The element to append to the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addParameter(ParameterDeclaration node) {
    List<ParameterDeclaration> list = (parent == null || state == null) ? getParameterListNoTransform() : getParameterList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addParameterNoTransform(ParameterDeclaration node) {
    List<ParameterDeclaration> list = getParameterListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the Parameter list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setParameter(ParameterDeclaration node, int i) {
    List<ParameterDeclaration> list = getParameterList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the Parameter list.
     * @return The node representing the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<ParameterDeclaration> getParameterList() {
    List<ParameterDeclaration> list = (List<ParameterDeclaration>) getChild(2);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the Parameter list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Parameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<ParameterDeclaration> getParameterListNoTransform() {
    return (List<ParameterDeclaration>) getChildNoTransform(2);
  }
  /**
   * 
     * Retrieves the Parameter list.
     * @return The node representing the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<ParameterDeclaration> getParameters() {
    return getParameterList();
  }
  /**
   * 
     * Retrieves the Parameter list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Parameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<ParameterDeclaration> getParametersNoTransform() {
    return getParameterListNoTransform();
  }
  /**
   * 
     * Replaces the Exception list.
     * @param list The new list node to be used as the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setExceptionList(List<Access> list) {
    setChild(list, 3);
  }
  /**
   * 
     * Retrieves the number of children in the Exception list.
     * @return Number of children in the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumException() {
    return getExceptionList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the Exception list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the Exception list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumExceptionNoTransform() {
    return getExceptionListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the Exception list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Access getException(int i) {
    return (Access) getExceptionList().getChild(i);
  }
  /**
   * 
     * Append an element to the Exception list.
     * @param node The element to append to the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addException(Access node) {
    List<Access> list = (parent == null || state == null) ? getExceptionListNoTransform() : getExceptionList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addExceptionNoTransform(Access node) {
    List<Access> list = getExceptionListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the Exception list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setException(Access node, int i) {
    List<Access> list = getExceptionList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the Exception list.
     * @return The node representing the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Access> getExceptionList() {
    List<Access> list = (List<Access>) getChild(3);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the Exception list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Exception list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Access> getExceptionListNoTransform() {
    return (List<Access>) getChildNoTransform(3);
  }
  /**
   * 
     * Retrieves the Exception list.
     * @return The node representing the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<Access> getExceptions() {
    return getExceptionList();
  }
  /**
   * 
     * Retrieves the Exception list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Exception list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<Access> getExceptionsNoTransform() {
    return getExceptionListNoTransform();
  }
  /**
   * 
     * Replaces the optional node for the Block child. This is the {@code Opt}
     * node containing the child Block, not the actual child!
     * @param opt The new node to be used as the optional node for the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void setBlockOpt(Opt<Block> opt) {
    setChild(opt, 4);
  }
  /**
   * 
     * Replaces the (optional) Block child.
     * @param node The new node to be used as the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBlock(Block node) {
    getBlockOpt().setChild(node, 0);
  }
  /**
   * 
     * Check whether the optional Block child exists.
     * @return {@code true} if the optional Block child exists, {@code false} if it does not.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public boolean hasBlock() {
    return getBlockOpt().getNumChild() != 0;
  }
  /**
   * 
     * Retrieves the (optional) Block child.
     * @return The Block child, if it exists. Returns {@code null} otherwise.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Block getBlock() {
    return (Block) getBlockOpt().getChild(0);
  }
  /**
   * 
     * Retrieves the optional node for the Block child. This is the {@code Opt} node containing the child Block, not the actual child!
     * @return The optional node for child the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Block> getBlockOpt() {
    return (Opt<Block>) getChild(4);
  }
  /**
   * 
     * Retrieves the optional node for child Block. This is the {@code Opt} node containing the child Block, not the actual child!
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The optional node for child Block.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Block> getBlockOptNoTransform() {
    return (Opt<Block>) getChildNoTransform(4);
  }
  /**
   * 
     * Replaces the TypeParameter list.
     * @param list The new list node to be used as the TypeParameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeParameterList(List<TypeVariable> list) {
    setChild(list, 5);
  }
  /**
   * 
     * Retrieves the number of children in the TypeParameter list.
     * @return Number of children in the TypeParameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumTypeParameter() {
    return getTypeParameterList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the TypeParameter list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the TypeParameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumTypeParameterNoTransform() {
    return getTypeParameterListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the TypeParameter list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the TypeParameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public TypeVariable getTypeParameter(int i) {
    return (TypeVariable) getTypeParameterList().getChild(i);
  }
  /**
   * 
     * Append an element to the TypeParameter list.
     * @param node The element to append to the TypeParameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addTypeParameter(TypeVariable node) {
    List<TypeVariable> list = (parent == null || state == null) ? getTypeParameterListNoTransform() : getTypeParameterList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addTypeParameterNoTransform(TypeVariable node) {
    List<TypeVariable> list = getTypeParameterListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the TypeParameter list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeParameter(TypeVariable node, int i) {
    List<TypeVariable> list = getTypeParameterList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the TypeParameter list.
     * @return The node representing the TypeParameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<TypeVariable> getTypeParameterList() {
    List<TypeVariable> list = (List<TypeVariable>) getChild(5);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the TypeParameter list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the TypeParameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<TypeVariable> getTypeParameterListNoTransform() {
    return (List<TypeVariable>) getChildNoTransform(5);
  }
  /**
   * 
     * Retrieves the TypeParameter list.
     * @return The node representing the TypeParameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<TypeVariable> getTypeParameters() {
    return getTypeParameterList();
  }
  /**
   * 
     * Retrieves the TypeParameter list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the TypeParameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<TypeVariable> getTypeParametersNoTransform() {
    return getTypeParameterListNoTransform();
  }
  /**
   * @apilevel internal
   */
  protected boolean rawMethodDecl_computed = false;
  /**
   * @apilevel internal
   */
  protected MethodDecl rawMethodDecl_value;
  /**
   * @attribute syn
   * @aspect GenericMethods
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:34
   */

  public MethodDecl rawMethodDecl() {
    

    
if(rawMethodDecl_computed) {
  return rawMethodDecl_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    rawMethodDecl_value = rawMethodDecl_compute();
      if(true){ rawMethodDecl_computed = true; }
        return rawMethodDecl_value;
  }
  /**
   * @apilevel internal
   */
  private MethodDecl rawMethodDecl_compute() {  return lookupParMethodDecl(new ArrayList());  }
  /**
   * @apilevel internal
   */
  protected java.util.Map lookupParMethodDecl_java_util_List_values;
  /**
   * @apilevel internal
   */
  protected List lookupParMethodDecl_java_util_List_list;
  /**
   * @attribute syn
   * @aspect GenericMethods
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:74
   */

  public MethodDecl lookupParMethodDecl(java.util.List typeArguments) {
    Object _parameters = typeArguments;
    if(lookupParMethodDecl_java_util_List_values == null) lookupParMethodDecl_java_util_List_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(lookupParMethodDecl_java_util_List_values.containsKey(_parameters)) {
  return (MethodDecl)lookupParMethodDecl_java_util_List_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    MethodDecl lookupParMethodDecl_java_util_List_value = lookupParMethodDecl_compute(typeArguments);
    if(lookupParMethodDecl_java_util_List_list == null) {
      lookupParMethodDecl_java_util_List_list = new List();
      lookupParMethodDecl_java_util_List_list.is$Final = true;
      lookupParMethodDecl_java_util_List_list.setParent(this);
    }
    lookupParMethodDecl_java_util_List_list.add(lookupParMethodDecl_java_util_List_value);
    if(lookupParMethodDecl_java_util_List_value != null) {
      lookupParMethodDecl_java_util_List_value = (MethodDecl) lookupParMethodDecl_java_util_List_list.getChild(lookupParMethodDecl_java_util_List_list.numChildren-1);
      lookupParMethodDecl_java_util_List_value.is$Final = true;
    }
      if(true){ lookupParMethodDecl_java_util_List_values.put(_parameters, lookupParMethodDecl_java_util_List_value); }
        return lookupParMethodDecl_java_util_List_value;
  }
  /**
   * @apilevel internal
   */
  private MethodDecl lookupParMethodDecl_compute(java.util.List typeArguments) {
      return newParMethodDecl(typeArguments);
    }
    /**
     * @attribute syn
     * @aspect GenericMethodsNameAnalysis
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:147
     */
  public SimpleSet localLookupType(String name) {
    ASTNode$State state = state();
    try {
        for(int i = 0; i < getNumTypeParameter(); i++) {
          if(original().getTypeParameter(i).name().equals(name))
            return SimpleSet.emptySet.add(original().getTypeParameter(i));
        }
        return SimpleSet.emptySet;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect LookupParTypeDecl
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:1276
     */
  public GenericMethodDecl original() {
    ASTNode$State state = state();
    try {  return original != null ? original : this;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect GenericsCodegen
     * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/GenericsCodegen.jrag:363
     */
  public boolean needsSignatureAttribute() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect GenericsCodegen
     * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/GenericsCodegen.jrag:482
     */
  public String methodTypeSignature() {
    ASTNode$State state = state();
    try {
        StringBuffer buf = new StringBuffer();
        buf.append("<");
        for(int i = 0; i < getNumTypeParameter(); i++) {
          TypeVariable param = getTypeParameter(i);
          buf.append(param.getID() + ":" + param.classBound() + param.interfaceBounds());
        }
        buf.append(">");
        buf.append(super.methodTypeSignature());
        return buf.toString();
      }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect GenericMethodsNameAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:146
   */

  public SimpleSet lookupType(String name) {
    ASTNode$State state = state();
    SimpleSet lookupType_String_value = getParent().Define_SimpleSet_lookupType(this, null, name);
        return lookupType_String_value;
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:144
   * @apilevel internal
   */
  public NameType Define_NameType_nameType(ASTNode caller, ASTNode child) {
    if(caller == getTypeParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return NameType.TYPE_NAME;
  }
    else {      return super.Define_NameType_nameType(caller, child);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericMethods.jrag:154
   * @apilevel internal
   */
  public SimpleSet Define_SimpleSet_lookupType(ASTNode caller, ASTNode child, String name) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return localLookupType(name).isEmpty() ? lookupType(name) : localLookupType(name);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
