/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * A resource declaration in a try with resources statement.
 * @production ResourceDeclaration : {@link VariableDeclaration};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java7/grammar/TryWithResources.ast:9
 */
public class ResourceDeclaration extends VariableDeclaration implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ResourceDeclaration clone() throws CloneNotSupportedException {
    ResourceDeclaration node = (ResourceDeclaration) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ResourceDeclaration copy() {
    try {
      ResourceDeclaration node = (ResourceDeclaration) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ResourceDeclaration fullCopy() {
    ResourceDeclaration tree = (ResourceDeclaration) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
     * Type checking for TWR.
     
   * @ast method
   * @aspect TryWithResources
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/TryWithResources.jrag:23
   */

  public void typeCheck() {
    TypeDecl typeAutoCloseable = lookupType("java.lang", "AutoCloseable");
    if (typeAutoCloseable == null)
      error("java.lang.AutoCloseable not found");
    else if (!getTypeAccess().type().instanceOf(typeAutoCloseable))
      error("Resource specification must declare an AutoCloseable resource");
  }
  /**
   * 
   * @ast method
   * @aspect TryWithResources
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/TryWithResources.jrag:156
   */

  public void nameCheck() {
    // Special name check for resource specification
    if (resourcePreviouslyDeclared(name()))
      error("A resource with the name "+name()+
          " has already been declared in this try statement.");

    // Do regular name check for variable declaration
    super.nameCheck();
  }
  /**
   * 
   * @ast method
   * 
   */

  public ResourceDeclaration() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[3];
    setChild(new Opt(), 2);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ResourceDeclaration(Modifiers p0, Access p1, String p2, Opt<Expr> p3) {
    setChild(p0, 0);
    setChild(p1, 1);
    setID(p2);
    setChild(p3, 2);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ResourceDeclaration(Modifiers p0, Access p1, beaver.Symbol p2, Opt<Expr> p3) {
    setChild(p0, 0);
    setChild(p1, 1);
    setID(p2);
    setChild(p3, 2);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 3;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
      }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Modifiers child.
     * @param node The new node to replace the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setModifiers(Modifiers node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * @return The current node used as the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiers() {
    return (Modifiers) getChild(0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Modifiers child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiersNoTransform() {
    return (Modifiers) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the TypeAccess child.
     * @param node The new node to replace the TypeAccess child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeAccess(Access node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the TypeAccess child.
     * @return The current node used as the TypeAccess child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Access getTypeAccess() {
    return (Access) getChild(1);
  }
  /**
   * 
     * Retrieves the TypeAccess child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the TypeAccess child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Access getTypeAccessNoTransform() {
    return (Access) getChildNoTransform(1);
  }
  /**
   * 
     * Replaces the lexeme ID.
     * @param value The new value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setID(String value) {
    tokenString_ID = value;
  }
  /**
   * 
     * JastAdd-internal setter for lexeme ID using the Beaver parser.
     * @param symbol Symbol containing the new value for the lexeme ID
     * @apilevel internal
     
   * @ast method
   * 
   */

  public void setID(beaver.Symbol symbol) {
    if(symbol.value != null && !(symbol.value instanceof String))
    throw new UnsupportedOperationException("setID is only valid for String lexemes");
    tokenString_ID = (String)symbol.value;
    IDstart = symbol.getStart();
    IDend = symbol.getEnd();
  }
  /**
   * 
     * Retrieves the value for the lexeme ID.
     * @return The value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public String getID() {
    return tokenString_ID != null ? tokenString_ID : "";
  }
  /**
   * 
     * Replaces the optional node for the Init child. This is the {@code Opt}
     * node containing the child Init, not the actual child!
     * @param opt The new node to be used as the optional node for the Init child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void setInitOpt(Opt<Expr> opt) {
    setChild(opt, 2);
  }
  /**
   * 
     * Replaces the (optional) Init child.
     * @param node The new node to be used as the Init child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setInit(Expr node) {
    getInitOpt().setChild(node, 0);
  }
  /**
   * 
     * Check whether the optional Init child exists.
     * @return {@code true} if the optional Init child exists, {@code false} if it does not.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public boolean hasInit() {
    return getInitOpt().getNumChild() != 0;
  }
  /**
   * 
     * Retrieves the (optional) Init child.
     * @return The Init child, if it exists. Returns {@code null} otherwise.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Expr getInit() {
    return (Expr) getInitOpt().getChild(0);
  }
  /**
   * 
     * Retrieves the optional node for the Init child. This is the {@code Opt} node containing the child Init, not the actual child!
     * @return The optional node for child the Init child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Expr> getInitOpt() {
    return (Opt<Expr>) getChild(2);
  }
  /**
   * 
     * Retrieves the optional node for child Init. This is the {@code Opt} node containing the child Init, not the actual child!
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The optional node for child Init.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Expr> getInitOptNoTransform() {
    return (Opt<Expr>) getChildNoTransform(2);
  }
  /**
     * Inherit the lookupType attribute in ResourceDeclaration.
     
   * @attribute inh
   * @aspect TryWithResources
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/TryWithResources.jrag:18
   */

  public TypeDecl lookupType(String packageName, String typeName) {
    ASTNode$State state = state();
    TypeDecl lookupType_String_String_value = getParent().Define_TypeDecl_lookupType(this, null, packageName, typeName);
        return lookupType_String_String_value;
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/TryWithResources.jrag:13
   * @apilevel internal
   */
  public NameType Define_NameType_nameType(ASTNode caller, ASTNode child) {
    if(caller == getTypeAccessNoTransform()) {
      return NameType.TYPE_NAME;
    }
    else {      return super.Define_NameType_nameType(caller, child);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
