/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production TryStmt : {@link Stmt} ::= <span class="component">{@link Block}</span> <span class="component">{@link CatchClause}*</span> <span class="component">[Finally:{@link Block}]</span> <span class="component">ExceptionHandler:{@link Block}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:223
 */
public class TryStmt extends Stmt implements Cloneable, FinallyHost {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public TryStmt clone() throws CloneNotSupportedException {
    TryStmt node = (TryStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public TryStmt copy() {
    try {
      TryStmt node = (TryStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public TryStmt fullCopy() {
    TryStmt tree = (TryStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        switch (i) {
        case 3:
          tree.children[i] = null;
          continue;
        }
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:91
   */

  public void collectBranches(Collection<Stmt> c) {
    c.addAll(escapedBranches());
  }
  /**
   * 
   * @ast method
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:915
   */

  public Block getFinallyBlock() {
    return getFinally();
  }
  /**
   * 
   * @ast method
   * @aspect ExceptionHandling
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:237
   */

  protected boolean reachedException(TypeDecl type) {
    boolean found = false;
    // found is true if the exception type is caught by a catch clause
    for(int i = 0; i < getNumCatchClause() && !found; i++)
      if(getCatchClause(i).handles(type))
        found = true;
    // if an exception is thrown in the block and the exception is not caught and
    // either there is no finally block or the finally block can complete normally
    if(!found && (!hasNonEmptyFinally() || getFinally().canCompleteNormally()) )
      if(getBlock().reachedException(type))
        return true;
    // even if the exception is caught by the catch clauses they may
    // throw new exceptions
    for(int i = 0; i < getNumCatchClause(); i++)
      if(getCatchClause(i).reachedException(type))
        return true;
    return hasNonEmptyFinally() && getFinally().reachedException(type);
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:813
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	s.append(indent());
	s.append("try ");
	getBlock().prettyPrint(s);
	for(int i = 0; i < getNumCatchClause(); i++) {
	  s.append(indent());
	  getCatchClause(i).prettyPrint(s);
	}
	if(hasFinally()) {
	  s.append(indent());
	  s.append("finally ");
	  getFinally().prettyPrint(s);
	}
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:707
   */

  public void toString(StringBuffer s) {
	s.append(indent());
	s.append("try ");
	getBlock().toString(s);
	for(int i = 0; i < getNumCatchClause(); i++) {
	  s.append(indent());
	  getCatchClause(i).toString(s);
	}
	if(hasFinally()) {
	  s.append(indent());
	  s.append("finally ");
	  getFinally().toString(s);
	}
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1540
   */

  public void createBCode(CodeGeneration gen) {
    int block_top_lbl = hostType().constantPool().newLabel();
    int block_end_lbl = hostType().constantPool().newLabel();
    int fallthrough_lbl = fallthrough_label();
    int handler_lbl = hostType().constantPool().newLabel();
    boolean needsHandler = false;

    super.createBCode(gen);
    gen.addLabel(block_top_lbl);
    getBlock().createBCode(gen);
    gen.addLabel(block_end_lbl);

    if (getBlock().canCompleteNormally()) {
      gen.emitGoto(fallthrough_lbl);
    }

    for (int i = 0; i < getNumCatchClause(); i++) {
      CatchClause cc = getCatchClause(i);
      cc.createBCode(gen);
      cc.exceptionTableEntries(gen, block_top_lbl, block_end_lbl);
      if (cc.getBlock().canCompleteNormally()) {
        gen.emitGoto(fallthrough_lbl);
      }
      if (hasNonEmptyFinally()) {
        int cc_end_lbl = hostType().constantPool().newLabel();
        gen.addLabel(cc_end_lbl);
        needsHandler = true;
        gen.addException(cc.label(), cc_end_lbl, handler_lbl,
            CodeGeneration.ExceptionEntry.CATCH_ALL);
      }
    }

    if (hasNonEmptyFinally()) {

      emitExceptionHandler(gen, block_top_lbl, block_end_lbl, handler_lbl,
          needsHandler);

      // fallthrough finally
      gen.addLabel(fallthrough_lbl);
      getFinally().createBCode(gen);
    }

    gen.addLabel(label_end());
  }
  /**
   * 
     * Generate catch-all (finally)
     
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1601
   */

  public void emitExceptionHandler(CodeGeneration gen, int start_lbl, int end_lbl, int handler_lbl, boolean needsHandler) {
    int top_pc = gen.addressOf(start_lbl);
    int end_pc = gen.addressOf(end_lbl);
    if (needsHandler || top_pc != end_pc) {
      // catch-all exception handler (finally)
      gen.addLabel(handler_lbl);
      gen.changeStackDepth(1);
      int num = getBlock().localNum();
      gen.emitStoreReference(num);
      getExceptionHandler().createBCode(gen);
      gen.emitLoadReference(num);
      gen.emit(Bytecode.ATHROW);

      gen.addException(start_lbl, end_lbl, handler_lbl,
          CodeGeneration.ExceptionEntry.CATCH_ALL);
    }
  }
  /**
   * 
   * @ast method
   * 
   */

  public TryStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[4];
    setChild(new List(), 1);
    setChild(new Opt(), 2);
  }
  /**
   * 
   * @ast method
   * 
   */

  public TryStmt(Block p0, List<CatchClause> p1, Opt<Block> p2) {
    setChild(p0, 0);
    setChild(p1, 1);
    setChild(p2, 2);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 3;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        branches_computed = false;
    branches_value = null;
    escapedBranches_computed = false;
    escapedBranches_value = null;
    isDAafter_Variable_values = null;
    isDUbefore_Variable_values = null;
    isDUafter_Variable_values = null;
    hasNonEmptyFinally_computed = false;
    catchableException_TypeDecl_values = null;
    getExceptionHandler_computed = false;
    getExceptionHandler_value = null;
    canCompleteNormally_computed = false;
    fallthrough_label_computed = false;
    label_end_computed = false;
    handlesException_TypeDecl_values = null;
    typeError_computed = false;
    typeError_value = null;
    typeRuntimeException_computed = false;
    typeRuntimeException_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Block child.
     * @param node The new node to replace the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBlock(Block node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Block child.
     * @return The current node used as the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Block getBlock() {
    return (Block) getChild(0);
  }
  /**
   * 
     * Retrieves the Block child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Block getBlockNoTransform() {
    return (Block) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the CatchClause list.
     * @param list The new list node to be used as the CatchClause list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setCatchClauseList(List<CatchClause> list) {
    setChild(list, 1);
  }
  /**
   * 
     * Retrieves the number of children in the CatchClause list.
     * @return Number of children in the CatchClause list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumCatchClause() {
    return getCatchClauseList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the CatchClause list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the CatchClause list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumCatchClauseNoTransform() {
    return getCatchClauseListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the CatchClause list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the CatchClause list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public CatchClause getCatchClause(int i) {
    return (CatchClause) getCatchClauseList().getChild(i);
  }
  /**
   * 
     * Append an element to the CatchClause list.
     * @param node The element to append to the CatchClause list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addCatchClause(CatchClause node) {
    List<CatchClause> list = (parent == null || state == null) ? getCatchClauseListNoTransform() : getCatchClauseList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addCatchClauseNoTransform(CatchClause node) {
    List<CatchClause> list = getCatchClauseListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the CatchClause list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setCatchClause(CatchClause node, int i) {
    List<CatchClause> list = getCatchClauseList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the CatchClause list.
     * @return The node representing the CatchClause list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<CatchClause> getCatchClauseList() {
    List<CatchClause> list = (List<CatchClause>) getChild(1);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the CatchClause list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the CatchClause list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<CatchClause> getCatchClauseListNoTransform() {
    return (List<CatchClause>) getChildNoTransform(1);
  }
  /**
   * 
     * Retrieves the CatchClause list.
     * @return The node representing the CatchClause list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<CatchClause> getCatchClauses() {
    return getCatchClauseList();
  }
  /**
   * 
     * Retrieves the CatchClause list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the CatchClause list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<CatchClause> getCatchClausesNoTransform() {
    return getCatchClauseListNoTransform();
  }
  /**
   * 
     * Replaces the optional node for the Finally child. This is the {@code Opt}
     * node containing the child Finally, not the actual child!
     * @param opt The new node to be used as the optional node for the Finally child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void setFinallyOpt(Opt<Block> opt) {
    setChild(opt, 2);
  }
  /**
   * 
     * Replaces the (optional) Finally child.
     * @param node The new node to be used as the Finally child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setFinally(Block node) {
    getFinallyOpt().setChild(node, 0);
  }
  /**
   * 
     * Check whether the optional Finally child exists.
     * @return {@code true} if the optional Finally child exists, {@code false} if it does not.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public boolean hasFinally() {
    return getFinallyOpt().getNumChild() != 0;
  }
  /**
   * 
     * Retrieves the (optional) Finally child.
     * @return The Finally child, if it exists. Returns {@code null} otherwise.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Block getFinally() {
    return (Block) getFinallyOpt().getChild(0);
  }
  /**
   * 
     * Retrieves the optional node for the Finally child. This is the {@code Opt} node containing the child Finally, not the actual child!
     * @return The optional node for child the Finally child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Block> getFinallyOpt() {
    return (Opt<Block>) getChild(2);
  }
  /**
   * 
     * Retrieves the optional node for child Finally. This is the {@code Opt} node containing the child Finally, not the actual child!
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The optional node for child Finally.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Block> getFinallyOptNoTransform() {
    return (Opt<Block>) getChildNoTransform(2);
  }
  /**
   * 
     * Replaces the ExceptionHandler child.
     * @param node The new node to replace the ExceptionHandler child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setExceptionHandler(Block node) {
    setChild(node, 3);
  }
  /**
   * 
     * Retrieves the ExceptionHandler child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the ExceptionHandler child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Block getExceptionHandlerNoTransform() {
    return (Block) getChildNoTransform(3);
  }
  /**
   * 
     * Retrieves the child position of the optional child ExceptionHandler.
     * @return The the child position of the optional child ExceptionHandler.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int getExceptionHandlerChildPosition() {
    return 3;
  }
  /**
   * @apilevel internal
   */
  protected boolean branches_computed = false;
  /**
   * @apilevel internal
   */
  protected Collection<Stmt> branches_value;
  /**
     * All branches that reach this node.
     
   * @attribute syn
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:138
   */

  public Collection<Stmt> branches() {
    

    
if(branches_computed) {
  return branches_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    branches_value = branches_compute();
      if(isFinal && num == state().boundariesCrossed){ branches_computed = true; }
        return branches_value;
  }
  /**
   * @apilevel internal
   */
  private Collection<Stmt> branches_compute() {
      Collection<Stmt> set = new HashSet<Stmt>();
      getBlock().collectBranches(set);
      for (int i = 0; i < getNumCatchClause(); i++) {
        getCatchClause(i).collectBranches(set);
      }
      return set;
    }
  /**
   * @apilevel internal
   */
  protected boolean escapedBranches_computed = false;
  /**
   * @apilevel internal
   */
  protected Collection<Stmt> escapedBranches_value;
  /**
     * All branches that escape this node
     
   * @attribute syn
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:150
   */

  public Collection<Stmt> escapedBranches() {
    

    
if(escapedBranches_computed) {
  return escapedBranches_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    escapedBranches_value = escapedBranches_compute();
      if(isFinal && num == state().boundariesCrossed){ escapedBranches_computed = true; }
        return escapedBranches_value;
  }
  /**
   * @apilevel internal
   */
  private Collection<Stmt> escapedBranches_compute() {
      Collection<Stmt> set = new HashSet<Stmt>();
      if (hasNonEmptyFinally()) {
        // branches from finally
        getFinally().collectBranches(set);
      }
      if (!hasFinally() || getFinally().canCompleteNormally()) {
        set.addAll(branches());
      }
      return set;
    }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:666
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {
      // 16.2.15 4th bullet
      if(!hasNonEmptyFinally()) {
        if(!getBlock().isDAafter(v))
          return false;
        for(int i = 0; i < getNumCatchClause(); i++)
          if(!getCatchClause(i).getBlock().isDAafter(v))
            return false;
        return true;
      }
      else {
        // 16.2.15 5th bullet
        if(getFinally().isDAafter(v))
          return true;
        if(!getBlock().isDAafter(v))
          return false;
        for(int i = 0; i < getNumCatchClause(); i++)
          if(!getCatchClause(i).getBlock().isDAafter(v))
            return false;
        return true;
      }
    }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:923
     */
  public boolean isDUafterFinally(Variable v) {
    ASTNode$State state = state();
    try {  return getFinally().isDUafter(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:926
     */
  public boolean isDAafterFinally(Variable v) {
    ASTNode$State state = state();
    try {  return getFinally().isDAafter(v);  }
    finally {
    }
  }
  protected java.util.Map isDUbefore_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1200
   */

  @SuppressWarnings({"unchecked", "cast"})
  public boolean isDUbefore(Variable v) {
    Object _parameters = v;
    if(isDUbefore_Variable_values == null) isDUbefore_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    ASTNode$State.CircularValue _value;
    

    
if(isDUbefore_Variable_values.containsKey(_parameters)) {
  Object _o = isDUbefore_Variable_values.get(_parameters);
  if(!(_o instanceof ASTNode$State.CircularValue)) {
    return ((Boolean)_o).booleanValue();
  } else { 
    _value = (ASTNode$State.CircularValue)_o;
  }
}
 else {
      _value = new ASTNode$State.CircularValue();
      isDUbefore_Variable_values.put(_parameters, _value);
      _value.value = Boolean.valueOf(true);
    }
    ASTNode$State state = state();
    if (!state.IN_CIRCLE) {
      state.IN_CIRCLE = true;
      int num = state.boundariesCrossed;
      boolean isFinal = this.is$Final();
      // TODO: fixme
      // state().CIRCLE_INDEX = 1;
      boolean new_isDUbefore_Variable_value;
      do {
        _value.visited = new Integer(state.CIRCLE_INDEX);
        state.CHANGE = false;
        new_isDUbefore_Variable_value = isDUbefore_compute(v);
        if (new_isDUbefore_Variable_value!=((Boolean)_value.value).booleanValue()) {
          state.CHANGE = true;
          _value.value = Boolean.valueOf(new_isDUbefore_Variable_value);
        }
        state.CIRCLE_INDEX++;
      } while (state.CHANGE);
        if(isFinal && num == state().boundariesCrossed) {
        isDUbefore_Variable_values.put(_parameters, new_isDUbefore_Variable_value);
      } else {
        isDUbefore_Variable_values.remove(_parameters);
        state.RESET_CYCLE = true;
isDUbefore_compute(v);
state.RESET_CYCLE = false;
      }
      state.IN_CIRCLE = false;
      return new_isDUbefore_Variable_value;
    }
    if (!new Integer(state.CIRCLE_INDEX).equals(_value.visited)) {
      _value.visited = new Integer(state.CIRCLE_INDEX);
      boolean new_isDUbefore_Variable_value = isDUbefore_compute(v);
      if (state.RESET_CYCLE) {
        isDUbefore_Variable_values.remove(_parameters);
      }
      else if (new_isDUbefore_Variable_value!=((Boolean)_value.value).booleanValue()) {
        state.CHANGE = true;
        _value.value = new_isDUbefore_Variable_value;
      }
      return new_isDUbefore_Variable_value;
    }
    return ((Boolean)_value.value).booleanValue();
  }
  /**
   * @apilevel internal
   */
  private boolean isDUbefore_compute(Variable v) {  return super.isDUbefore(v);  }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1236
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {
      // 16.2.14 4th bullet
      if(!hasNonEmptyFinally()) {
        if(!getBlock().isDUafter(v))
          return false;
        for(int i = 0; i < getNumCatchClause(); i++)
          if(!getCatchClause(i).getBlock().isDUafter(v))
            return false;
        return true;
      }
      else
        return getFinally().isDUafter(v);
    }
  /**
   * @apilevel internal
   */
  protected boolean hasNonEmptyFinally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean hasNonEmptyFinally_value;
  /**
     * @return <code>true</code> if this TyStmt has a non-empty finally block
     
   * @attribute syn
   * @aspect ExceptionHandling
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:15
   */

  public boolean hasNonEmptyFinally() {
    

    
if(hasNonEmptyFinally_computed) {
  return hasNonEmptyFinally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    hasNonEmptyFinally_value = hasNonEmptyFinally_compute();
      if(isFinal && num == state().boundariesCrossed){ hasNonEmptyFinally_computed = true; }
        return hasNonEmptyFinally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean hasNonEmptyFinally_compute() {  return hasFinally() && getFinally().getNumStmt() > 0;  }
  protected java.util.Map catchableException_TypeDecl_values;
  /**
     * The block of the try statement can throw an exception of
     * a type assignable to the given type.
     
   * @attribute syn
   * @aspect ExceptionHandling
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:227
   */

  public boolean catchableException(TypeDecl type) {
    Object _parameters = type;
    if(catchableException_TypeDecl_values == null) catchableException_TypeDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(catchableException_TypeDecl_values.containsKey(_parameters)) {
  return ((Boolean)catchableException_TypeDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean catchableException_TypeDecl_value = catchableException_compute(type);
      if(isFinal && num == state().boundariesCrossed){ catchableException_TypeDecl_values.put(_parameters, Boolean.valueOf(catchableException_TypeDecl_value)); }
        return catchableException_TypeDecl_value;
  }
  /**
   * @apilevel internal
   */
  private boolean catchableException_compute(TypeDecl type) {  return getBlock().reachedException(type);  }
  /**
   * @apilevel internal
   */
  protected boolean getExceptionHandler_computed = false;
  /**
   * @apilevel internal
   */
  protected Block getExceptionHandler_value;
  /**
     * Copy of the finally block for catch-all exception handling.
     
   * @attribute syn nta
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NTAFinally.jrag:66
   */

  public Block getExceptionHandler() {
    

if(getExceptionHandler_computed) {
  return (Block) getChild(getExceptionHandlerChildPosition());
}
    
if(getExceptionHandler_computed) {
  return getExceptionHandler_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    getExceptionHandler_value = getExceptionHandler_compute();
      setExceptionHandler(getExceptionHandler_value);
      if(isFinal && num == state().boundariesCrossed){ getExceptionHandler_computed = true; }
    Block node = (Block) this.getChild(getExceptionHandlerChildPosition());
        return node;
  }
  /**
   * @apilevel internal
   */
  private Block getExceptionHandler_compute() {
      if (hasNonEmptyFinally()) {
        NTAFinallyBlock ntaBlock = new NTAFinallyBlock(this);
        ntaBlock.addStmt((Block) getFinally().fullCopy());
        return ntaBlock;
      } else {
        return new NTAFinallyBlock();
      }
    }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:113
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {
       boolean anyCatchClauseCompleteNormally = false;
       for(int i = 0; i < getNumCatchClause() && !anyCatchClauseCompleteNormally; i++)
         anyCatchClauseCompleteNormally = getCatchClause(i).getBlock().canCompleteNormally();
       return (getBlock().canCompleteNormally() || anyCatchClauseCompleteNormally) &&
         (!hasNonEmptyFinally() || getFinally().canCompleteNormally());
    }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1446
     */
  public int break_label() {
    ASTNode$State state = state();
    try {  return label_end();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1470
     */
  public int continue_label() {
    ASTNode$State state = state();
    try {  return label_end();  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean fallthrough_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int fallthrough_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1537
   */

  public int fallthrough_label() {
    

    
if(fallthrough_label_computed) {
  return fallthrough_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    fallthrough_label_value = fallthrough_label_compute();
      if(isFinal && num == state().boundariesCrossed){ fallthrough_label_computed = true; }
        return fallthrough_label_value;
  }
  /**
   * @apilevel internal
   */
  private int fallthrough_label_compute() {  return hasNonEmptyFinally() ? hostType().constantPool().newLabel() : label_end();  }
    /**
       * Outer finally host with a finally block that can complete normally
       
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1588
     */
  public FinallyHost outerFinallyHost() {
    ASTNode$State state = state();
    try {
        // find outer finally
        FinallyHost outer = this;
        Iterator<FinallyHost> iter = finallyIterator();
        while (iter.hasNext()) {
          outer = iter.next();
        }
        return outer;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {
        if (getBlock().modifiedInScope(var))
          return true;
        for (CatchClause cc : getCatchClauseList())
          if (cc.modifiedInScope(var))
            return true;
        return hasNonEmptyFinally() && getFinally().modifiedInScope(var);
      }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean label_end_computed = false;
  /**
   * @apilevel internal
   */
  protected int label_end_value;
  /**
   * @attribute syn
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/NTAFinally.jrag:30
   */

  public int label_end() {
    

    
if(label_end_computed) {
  return label_end_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    label_end_value = label_end_compute();
      if(isFinal && num == state().boundariesCrossed){ label_end_computed = true; }
        return label_end_value;
  }
  /**
   * @apilevel internal
   */
  private int label_end_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @attribute inh
   * @aspect ExceptionHandling
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:55
   */

  public boolean handlesException(TypeDecl exceptionType) {
    Object _parameters = exceptionType;
    if(handlesException_TypeDecl_values == null) handlesException_TypeDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(handlesException_TypeDecl_values.containsKey(_parameters)) {
  return ((Boolean)handlesException_TypeDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean handlesException_TypeDecl_value = getParent().Define_boolean_handlesException(this, null, exceptionType);
      if(isFinal && num == state().boundariesCrossed){ handlesException_TypeDecl_values.put(_parameters, Boolean.valueOf(handlesException_TypeDecl_value)); }
        return handlesException_TypeDecl_value;
  }
  protected java.util.Map handlesException_TypeDecl_values;
  /**
   * @attribute inh
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:138
   */

  public TypeDecl typeError() {
    

    
if(typeError_computed) {
  return typeError_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    typeError_value = getParent().Define_TypeDecl_typeError(this, null);
      if(isFinal && num == state().boundariesCrossed){ typeError_computed = true; }
        return typeError_value;
  }
  /**
   * @apilevel internal
   */
  protected boolean typeError_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl typeError_value;
  /**
   * @attribute inh
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:139
   */

  public TypeDecl typeRuntimeException() {
    

    
if(typeRuntimeException_computed) {
  return typeRuntimeException_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    typeRuntimeException_value = getParent().Define_TypeDecl_typeRuntimeException(this, null);
      if(isFinal && num == state().boundariesCrossed){ typeRuntimeException_computed = true; }
        return typeRuntimeException_value;
  }
  /**
   * @apilevel internal
   */
  protected boolean typeRuntimeException_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl typeRuntimeException_value;
  /**
   * @attribute inh
   * @aspect CodeGeneration
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:394
   */

  public TypeDecl typeThrowable() {
    ASTNode$State state = state();
    TypeDecl typeThrowable_value = getParent().Define_TypeDecl_typeThrowable(this, null);
        return typeThrowable_value;
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:249
   * @apilevel internal
   */
  public FinallyHost Define_FinallyHost_enclosingFinally(ASTNode caller, ASTNode child, Stmt branch) {
    if(caller == getFinallyOptNoTransform()) {
      return enclosingFinally(branch);
    }
    else  {
      int childIndex = this.getIndexOfChild(caller);
      return hasNonEmptyFinally() ? this : enclosingFinally(branch);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:665
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getFinallyOptNoTransform()) {
      return isDAbefore(v);
    }
    else if(caller == getCatchClauseListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return getBlock().isDAbefore(v);
  }
    else if(caller == getBlockNoTransform()) {
      return isDAbefore(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1227
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getFinallyOptNoTransform()){
    if(!getBlock().isDUeverywhere(v))
      return false;
    for(int i = 0; i < getNumCatchClause(); i++)
      if(!getCatchClause(i).getBlock().unassignedEverywhere(v, this))
        return false;
    return true;
  }
    else if(caller == getCatchClauseListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    {
    if(!getBlock().isDUafter(v))
      return false;
    if(!getBlock().isDUeverywhere(v))
      return false;
    return true;
  }
  }
    else if(caller == getBlockNoTransform()) {
      return isDUbefore(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:208
   * @apilevel internal
   */
  public boolean Define_boolean_handlesException(ASTNode caller, ASTNode child, TypeDecl exceptionType) {
    if(caller == getBlockNoTransform()){
    for(int i = 0; i < getNumCatchClause(); i++)
      if(getCatchClause(i).handles(exceptionType))
        return true;
    if(hasNonEmptyFinally() && !getFinally().canCompleteNormally())
      return true;
    return handlesException(exceptionType);
  }
    else if(caller == getCatchClauseListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    {
    if(hasNonEmptyFinally() && !getFinally().canCompleteNormally())
      return true;
    return handlesException(exceptionType);
  }
  }
    else {      return getParent().Define_boolean_handlesException(this, caller, exceptionType);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:121
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getFinallyOptNoTransform()) {
      return reachable();
    }
    else if(caller == getBlockNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:128
   * @apilevel internal
   */
  public boolean Define_boolean_reachableCatchClause(ASTNode caller, ASTNode child, TypeDecl exceptionType) {
    if(caller == getCatchClauseListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    {
    for(int i = 0; i < childIndex; i++)
      if(getCatchClause(i).handles(exceptionType))
        return false;
    if(catchableException(exceptionType))
      return true;
    if(exceptionType.mayCatch(typeError()) || exceptionType.mayCatch(typeRuntimeException()))
      return true;
    return false;
  }
  }
    else {      return getParent().Define_boolean_reachableCatchClause(this, caller, exceptionType);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:156
   * @apilevel internal
   */
  public boolean Define_boolean_reportUnreachable(ASTNode caller, ASTNode child) {
    if(caller == getFinallyOptNoTransform()) {
      return reachable();
    }
    else if(caller == getCatchClauseListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return reachable();
  }
    else if(caller == getBlockNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reportUnreachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:133
   * @apilevel internal
   */
  public int Define_int_localNum(ASTNode caller, ASTNode child) {
    if(caller == getExceptionHandlerNoTransform()) {
      return localNum();
    }
    else if(caller == getFinallyOptNoTransform()) {
      return localNum();
    }
    else  {
      int childIndex = this.getIndexOfChild(caller);
{
    if (hasNonEmptyFinally()) {
      return localNum() + 1;
    } else {
      return localNum();
    }
  }
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:138
   * @apilevel internal
   */
  public Collection<TypeDecl> Define_Collection_TypeDecl__caughtExceptions(ASTNode caller, ASTNode child) {
    if(caller == getCatchClauseListNoTransform())  {
    int index = caller.getIndexOfChild(child);
    {
    Collection<TypeDecl> excp = new HashSet<TypeDecl>();
    getBlock().collectExceptions(excp, this);
    Collection<TypeDecl> caught = new LinkedList<TypeDecl>();
    Iterator<TypeDecl> iter = excp.iterator();
    while (iter.hasNext()) {
      TypeDecl exception = iter.next();
      // this catch clause handles the exception
      if (!getCatchClause(index).handles(exception))
        continue;
      // no previous catch clause handles the exception
      boolean already = false;
      for (int i = 0; i < index; ++i) {
        if (getCatchClause(i).handles(exception)) {
          already = true;
          break;
        }
      }
      if (!already) {
        caught.add(exception);
      }
    }
    return caught;
  }
  }
    else {      return getParent().Define_Collection_TypeDecl__caughtExceptions(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
